#!/usr/local/bin/perl

# ===========================================================================
# File: addreview.cgi
# Provided by: Dr. Kevin Ham
# http://www.hostglobal.com - Web Hosting & Resource Directory 
# Version 1.0
# This script is freeware only on the condition that you rate and review your
# your host at http://hostglobal.com OR add an appropriate resource.
# You may not redistribute this script or a modification of it without consent.
# If you would like updates and support for this script, send me a $30 US cheque.
# Email me at kdham@mail.puterdudes.com for the address.
# =============================================================================


# Required Libraries
# --------------------------------------------------------
eval {
    ($0 =~ m,(.*)/[^/]+,)   && unshift (@INC, "$1");    # Get the script location: UNIX /
    ($0 =~ m,(.*)\\[^\\]+,) && unshift (@INC, "$1");    # Get the script location: Windows \

    require "review.cfg";
    require "header_footer.cfg";  # Change this to full path if you have problems. Can be left if
                                  # in the same directory as this script
};


if ($@) {
    print "Content-type: text/plain\n\n";
    print "Error including libraries: $@\n";
    print "Make sure they exist, permissions are set properly, and paths are set correctly.";
    exit;
}

#=========================
local (%in) = &parse_form;

$domain=$in{'url'};
$ID=$in{'ID'};

#**************************************************************************************
# ====== If you want to add more variables from your link in your Links page
# eg. Title, email address, you need to add the variables like above.
# eg $title=$in{'Title'} and also add this in your link from the calling page
# eg. <a href="http://URL/to/addreview.cgi?ID=<%ID%>&url=<%URL%>&Title=<%Title%>Review It</a>
# You must then add these new fields in processreview.cgi
#******************************************************************************************

&addreview_form;
exit;
#=========================


# =====================================================================
sub addreview_form{
# =====================================================================
& print_header;

print<<REQUEST_FORM;

<h2 align="center">Add your review for <a href="$link_location/jump.cgi?ID=$ID">$domain</a></h2>

<form ACTION="$link_location/processreview.cgi" METHOD="POST">
  <input type="hidden" name="ID" value="$ID">
  <input type="hidden" name="url" value="$domain">
  <input type="hidden" name="IP" value="$ENV{'REMOTE_ADDR'}">
<div align="center"><center><table BORDER="1" width="381">
    <tr>
      <td BGCOLOR="e0e0e0" width="62"><b>Name:</b></td>
      <td width="307"><input NAME="name" size="20"></td>
    </tr>
    <tr>
      <td BGCOLOR="e0e0e0" width="62"><b>E-mail:</b></td>
      <td width="307"><input TYPE="TEXT" NAME="email" size="20"></td>
    </tr>
    <tr>
      <td BGCOLOR="e0e0e0" width="62"><b>Your Site:</b></td>
      <td width="307"><input NAME="site" size="20"></td>
    </tr>
    <tr>
      <td BGCOLOR="e0e0e0" width="62"><b>Support:</b></td>
      <td width="307"><select name="support" size="1">
    <option>Excellent </option>
    <option>Good </option>
    <option>Fair </option>
    <option>Poor </option>
  </select></td>
    </tr>
      <td BGCOLOR="e0e0e0" width="62"><b>Recommendation:</b></td>
      <td BGCOLOR="FFFFFF" width="307"><select name="rating" size="1">
    <option>Excellent </option>
    <option>Good </option>
    <option>Fair </option>
    <option>Poor </option>
  </select></td>
    </tr>
    
    <tr>
      <td BGCOLOR="e0e0e0" width="62"><b>Review:</b></td>
      <td width="307"><textarea rows="2" name="review" cols="31"></textarea></td>
    </tr>
    <tr>
      <td COLSPAN="2" BGCOLOR="FFFFFF" width="375"><div align="center"><center><p><input
      TYPE="submit" VALUE="Add Review"></td>
    </tr>
  </table>
  </center></div></font>
</form>

<p>&nbsp;</p>
REQUEST_FORM

& print_footer;
} # End of sub addreview_form

sub parse_form {
# --------------------------------------------------------
# Parses the form input and returns a hash with all the name
# value pairs. Removes any field with "---" as a value 
# (as this denotes an empty SELECT field.
#
    my (@pairs, %in);
    my ($buffer, $pair, $name, $value); 
        
    if ($ENV{'REQUEST_METHOD'} eq 'GET') {
        @pairs = split(/&/, $ENV{'QUERY_STRING'});
    }
    elsif ($ENV{'REQUEST_METHOD'} eq 'POST') {
        read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
        @pairs = split(/&/, $buffer);
    }
    else {
        &cgierr('You cant run this script from telnet/shell.');
    }
    
    PAIR: foreach $pair (@pairs) {
        ($name, $value) = split(/=/, $pair);
         
        $name =~ tr/+/ /;
        $name =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;

        $value =~ tr/+/ /;
        $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;

        ($value eq "---") and next PAIR; 
        exists $in{$name} ? ($in{$name} .= "~~$value") : ($in{$name}  = $value);
    }
    return %in;
}

sub cgierr {
# --------------------------------------------------------
# Displays any errors and prints out FORM and ENVIRONMENT 
# information. Useful for debugging.
#
    if (!$html_headers_printed) {
        print "Content-type: text/html\n\n";
        $html_headers_printed = 1;
    }
    print "<PRE>\n\nCGI ERROR\n==========================================\n";
    $_[0]      and print "Error Message       : $_[0]\n";   
    $0         and print "Script Location     : $0\n";
    $]         and print "Perl Version        : $]\n";  
    
    print "\nForm Variables\n-------------------------------------------\n";
    foreach $key (sort keys %in) {
        my $space = " " x (20 - length($key));
        print "$key$space: $in{$key}\n";
    }
    print "\nEnvironment Variables\n-------------------------------------------\n";
    foreach $env (sort keys %ENV) {
        my $space = " " x (20 - length($env));
        print "$env$space: $ENV{$env}\n";
    }
    print "\n</PRE>";
    exit -1;
}