#!/usr/bin/perl

# Required Librariers
# --------------------------------------------------------
eval {
    ($0 =~ m,(.*)/[^/]+,)   && unshift (@INC, "$1");    # Get the script location: UNIX /
    ($0 =~ m,(.*)\\[^\\]+,) && unshift (@INC, "$1");    # Get the script location: Windows \

    require "/www/hostglobal/cgi-bin/links/admin/links.cfg";              # Change this to full path to links.cfg if you have problems.
    require "$db_lib_path/db_utils.pl";
    require "$db_lib_path/links.def";
    require "header_footer.cfg";
};

local (%in) = &parse_form;
      $ID = $in{'ID'};

#***********************************************************************************************
#====Edit these variables to fit your message and path ======================================

# path to review database (I know you filled this out in review.cfg but it seems to want it here.)
$db_review = "/path/to/review.db";

# path to links files - the directory where Detailed, links, categories are *not where you cgi's are
$links_files = "http\://URL/to/links"; # this is to link to your Detailed pages so turn it on in links.cfg

# message if there is no Review from admin (you)
$noreviewadmin="The administration has yet to review this site and their service.";

# message if there are no User Reviews
$noreviewuser="No user reviews at this time.  Please add one if you have used this resource before.";

#************************************************************************************************
###################################################################
#### Actual cgi program
###################################################################
&find_reviews;
$count=@matches;
&no_matches if ($count==0);
exit;
# End of program


###################################################################
sub find_reviews{
###################################################################

######## Open Links.db for admin review #####
# Link database stores a list link attributes.
 open  (LINK, "$db_links_name")  or &cgierr("unable to open url index $db_url_name. Reason: $!");

# Go through the Links database and find the link we want to go to.
		LINE: while (<LINK>) {
			next LINE if (/^#/);		# Skip comment lines.
			next LINE if (/^\s*$/);		# Skip blank lines.
                        @links=split (/\|/);
                      if ($links[0]==$ID){
                        push @matches,$_;
                      } # end of if
                      } # end of while
                close (LINK);

& print_header;

print<<"END_OF_TEXT";
<div align="center"><center>
<table border="0" cellpadding="0" cellspacing="0" width="600">
      <tr>
        <td bgcolor="#FFFFFF"><p align="center"><big><strong><font color="#005C9D">Admin Review</font></strong></big></td>
      </tr>
      <tr>
END_OF_TEXT

foreach $lines(@matches){
chomp $lines;

#**********************************************************************************************
#==========  Edit this line to match the columns in your links.db file ========================
#========== Just give them any name eg. $review or $my_review==================================

 ($key, $title, $url, $date, $category, $AltCategories, $description,
 $contact_name, $contact_email, $hits, $isNew, $isPopular, $rating, $votes, $receivemail,
 $memberstatus, $affiliate, $affiliateURL, $affiliatepay, $affiliateno,
 $asofmonth, $asofyear,$isPick, $review, $revchoice) = split (/\|/,$lines);

#***********************************************************************************************


print<<"END_OF_TEXT";
   <td><center><font color="#000000"><strong>Review of <a href="$links_files/Detailed/$key.html">$title</a>
     with an average rating of <font color="#005C9D">$rating </font>and <font color="#005C9D">$hits</font> hits.</strong></font></center>
 <div align="center"><center>
END_OF_TEXT

if ($review=" "){ # if no review

print<<"END_OF_TEXT";
 <table border="0" cellpadding="5" width="575" bgcolor="#EFEFEF">
     <tr>
         <td>$noreviewadmin</td>
     </tr>
 </table>
 </center></div>
    </td>
END_OF_TEXT
} # end of if

else { # if review present
print<<"END_OF_TEXT";
  <table border="0" cellpadding="5" width="575" bgcolor="#EFEFEF">
      <tr>
          <td>$review</td>
      </tr>
  </table>
  </center></div>
     </td>
END_OF_TEXT
} # end of else
}#end of foreach 


          open (REVIEWS,"$db_review") or &cgierr("unable to open url index $db_url_name. Reason: $!");
          LINE: while(<REVIEWS>){
		next LINE if (/^#/);		# Skip comment lines.
		next LINE if (/^\s*$/);		# Skip blank lines.
          @data=split (/\|/);
          if ($data[1]==$ID){
             push @match,$_;
             } # End of if
          } #end of while
          close (REVIEWS);

$found=@match;

print<<"END_OF_TEXT";
 </tr>
</table>
</center></div><br>

<p align="center"><big><font color="#005C9D">....................................</font></big></p>

  <div align="center"><center>
  <table border="0" cellpadding="2" width="600">
      <tr>
        <td bgcolor="#FFFFFF"><p align="center"><font color="#005C9D"><big><strong>$found User Review(s)</strong></big></font></td>
      </tr>
  </table>
  </center></div>
END_OF_TEXT

if ($found == 0) {
 print<<"END_OF_TEXT"; 
   <table border="0" cellpadding="5" width="575"><div align="center"><center>
      <tr>
         <td bgcolor="#EFEFEF">$noreviewuser</td>
      </tr>
      <tr><td><br></td></tr>
   </table> </center></div>      
END_OF_TEXT
} # end of if

else {
foreach $line(@match){
chomp $line;

#**********************************************************************************************
#== Edit these variables if you've changed them in addreview.cgi and also in processreview.cgi
($time,$ref,$url,$name,$email,$site,$IP,$support,$rating,$comments) = split (/\|/,$line);
#**********************************************************************************************

print<<"END_OF_TEXT";   
    <table border="0" cellpadding="0" width="600"><div align="center"><center>
       <tr>
         <td bgcolor="#EFEFEF"><font color="#000000"><strong><a href="http://$site">$name</a></strong>
         <font color="#000000"> ($email - $IP)</font></td>
       </tr>
       <tr>
         <td colspan="2" bgcolor="#FFFFFF">$comments</td>
       </tr>
       <tr>
         <td colspan="2" bgcolor="#EFEFEF" align="left"><font color="#000000">Recommendation: <strong><font color="#005C9D">$rating</font></strong>
         - Support: <strong><font color="#005C9D">$support</font></font></strong></td>
       </tr>  
       <tr><td><br></td></tr>
    </table></center></div>
END_OF_TEXT
}#end of foreach    
  } # end of else

& print_footer;
} # end of subroutine find_reviews   


### Subroutine no_matches ####
sub no_matches{
&print_header;
 print<<"END_OF_TEXT";
 <center>
  Sorry there were not any matches in Reviews for Resource $ID.
 </center>
END_OF_TEXT
&print_footer;
exit;
}
### end of no_matches subroutine